unsigned long long fastfillrect(unsigned int *sense,unsigned int *x,unsigned int *y, unsigned int *width,unsigned int *height,unsigned int *numcols, unsigned int *numrows,unsigned long long screen[]){
     union utype{
        unsigned long long b;
        unsigned char a[8];
    }work;
    unsigned int i,j,xend,yend,row,bitnum,plotwidth,plotheight;
    if(*x+*width>*numcols){ //ensure the width stays within bounds
        plotwidth=*numcols-*x;
    }
    else{
        plotwidth=*width;
    }
    xend=*x+plotwidth;
    if(*y+*height>*numrows){ //ensure the height stays within bounds
        plotheight=*numrows-*y;
    }
    else{
        plotheight=*height;
    }
    yend=*y+plotheight;
    for (j=*y ; j<yend  ;j++){
       row=j/8; //pick the byte
       bitnum=j-(row*8);
        for (i=*x ; i<xend ; i++){
            work.b=screen[i];
            if (*sense)
                work.a[row]=work.a[row] | (1<<bitnum);
            else
                work.a[row]=work.a[row] & ~(1<<bitnum);
            screen[i]=work.b;
        }
    }
    return bitnum;
}
unsigned long long getnextupdate(unsigned int *outchar,unsigned int *col, unsigned int *row,unsigned int *maxcols,unsigned int *maxrows, unsigned long long screen[], unsigned long long displayed[]){
     union utype{
        unsigned long long b;
        unsigned char a[8];
    }in,out;
    int i,j;
    for (j=*row;j<*maxrows;j++){
        for (i=*col;i<*maxcols;i++){
            in.b=screen[i];
            out.b=displayed[i];
            if (in.a[j]!=out.a[j]){ //an update found'
                out.a[j]=in.a[j]; //update what is being displayed
                displayed[i]=out.b;
                *outchar=in.a[j];
                if(j==*row && i==*col+1 ){
                    *col=i;
                    *row=j;
                    return 0; //no need to update cursor
                }
                else{
                    *col=i;
                    *row=j;
                    return 1; //need to update cursor
                }
            }
        }
        *col=0;
    }
    return 2;
}
unsigned long long drawPixel(unsigned int *onoff, unsigned int *x, unsigned int *y, unsigned int *rotation, unsigned int *width, unsigned int *height, unsigned int *rot_width, unsigned int *rot_height, unsigned long long p_array[]){
    unsigned long long xp,yp,a;
     union utype{
        unsigned long long b;
        unsigned long a[2];
    }u;
    switch(*rotation) {
  case 0: //normal/
       xp=*x;
       yp=*y;
       break;
   case 1: //invert/
       xp=*width-*x-1;
       yp=*height-*y-1;
     break;
   case 2: //rotate right
       yp=*x;
       xp=*width-*y-1;
       break;
   case 3: //rotate left
       yp=*height-*x-1;
       xp=*y;
   }
    if ((xp<*rot_width) & (yp< *rot_height) & (xp>=0) & (yp>=0) ){
       if(*onoff)  {
          u.b=0;
          if (yp<32)
             u.a[0]=1 << yp;
           else
              u.a[1]=1<<(yp-32);
          p_array[xp]=p_array[xp] | u.b;
       }
       else{
         u.b=0xFFFFFFFFFFFFFFFF;
         if (yp<32)
           u.a[0]=u.a[0]^(1 << yp);
         else
           u.a[1]=u.a[1]^(1<<(yp-32));
         p_array[xp]=p_array[xp] & u.b;
       }
     }
  return u.b;

}
long long charload(long long loadarray[]) {
unsigned int i;
  loadarray[0]=0x0000000000;
  loadarray[1]=0x3E5B4F5B3E00;
  loadarray[2]=0x3E6B4F6B3E00;
  loadarray[3]=0x1C3E7C3E1C00;
  loadarray[4]=0x183C7E3C1800;
  loadarray[5]=0x1C577D571C00;
  loadarray[6]=0x1C5E7F5E1C00;
  loadarray[7]=0x183C180000;
  loadarray[8]=0xFFE7C3E7FF00;
  loadarray[9]=0x1824180000;
  loadarray[10]=0xFFE7DBE7FF00;
  loadarray[11]=0x30483A060E00;
  loadarray[12]=0x262979292600;
  loadarray[13]=0x407F05050700;
  loadarray[14]=0x407F05253F00;
  loadarray[15]=0x5A3CE73C5A00;
  loadarray[16]=0x7F3E1C1C0800;
  loadarray[17]=0x081C1C3E7F00;
  loadarray[18]=0x14227F221400;
  loadarray[19]=0x5F5F005F5F00;
  loadarray[20]=0x06097F017F00;
  loadarray[21]=0x6689956A00;
  loadarray[22]=0x606060606000;
  loadarray[23]=0x94A2FFA29400;
  loadarray[24]=0x08047E040800;
  loadarray[25]=0x10207E201000;
  loadarray[26]=0x08082A1C0800;
  loadarray[27]=0x081C2A080800;
  loadarray[28]=0x1E1010101000;
  loadarray[29]=0x0C1E0C1E0C00;
  loadarray[30]=0x30383E383000;
  loadarray[31]=0x060E3E0E0600;
  loadarray[32]=0x0000000000;
  loadarray[33]=0x005F000000;
  loadarray[34]=0x0700070000;
  loadarray[35]=0x147F147F1400;
  loadarray[36]=0x242A7F2A1200;
  loadarray[37]=0x231308646200;
  loadarray[38]=0x364956205000;
  loadarray[39]=0x0807030000;
  loadarray[40]=0x1C22410000;
  loadarray[41]=0x41221C0000;
  loadarray[42]=0x2A1C7F1C2A00;
  loadarray[43]=0x08083E080800;
  loadarray[44]=0x8070300000;
  loadarray[45]=0x080808080800;
  loadarray[46]=0x0060600000;
  loadarray[47]=0x201008040200;
  loadarray[48]=0x3E5149453E00;
  loadarray[49]=0x427F400000;
  loadarray[50]=0x724949494600;
  loadarray[51]=0x2141494D3300;
  loadarray[52]=0x1814127F1000;
  loadarray[53]=0x274545453900;
  loadarray[54]=0x3C4A49493100;
  loadarray[55]=0x412111090700;
  loadarray[56]=0x364949493600;
  loadarray[57]=0x464949291E00;
  loadarray[58]=0x0014000000;
  loadarray[59]=0x4034000000;
  loadarray[60]=0x0814224100;
  loadarray[61]=0x141414141400;
  loadarray[62]=0x4122140800;
  loadarray[63]=0x020159090600;
  loadarray[64]=0x3E415D594E00;
  loadarray[65]=0x7C1211127C00;
  loadarray[66]=0x7F4949493600;
  loadarray[67]=0x3E4141412200;
  loadarray[68]=0x7F4141413E00;
  loadarray[69]=0x7F4949494100;
  loadarray[70]=0x7F0909090100;
  loadarray[71]=0x3E4141517300;
  loadarray[72]=0x7F0808087F00;
  loadarray[73]=0x417F410000;
  loadarray[74]=0x2040413F0100;
  loadarray[75]=0x7F0814224100;
  loadarray[76]=0x7F4040404000;
  loadarray[77]=0x7F021C027F00;
  loadarray[78]=0x7F0408107F00;
  loadarray[79]=0x3E4141413E00;
  loadarray[80]=0x7F0909090600;
  loadarray[81]=0x3E4151215E00;
  loadarray[82]=0x7F0919294600;
  loadarray[83]=0x264949493200;
  loadarray[84]=0x03017F010300;
  loadarray[85]=0x3F4040403F00;
  loadarray[86]=0x1F2040201F00;
  loadarray[87]=0x3F4038403F00;
  loadarray[88]=0x631408146300;
  loadarray[89]=0x030478040300;
  loadarray[90]=0x6159494D4300;
  loadarray[91]=0x7F41414100;
  loadarray[92]=0x020408102000;
  loadarray[93]=0x4141417F00;
  loadarray[94]=0x040201020400;
  loadarray[95]=0x404040404000;
  loadarray[96]=0x0307080000;
  loadarray[97]=0x205454784000;
  loadarray[98]=0x7F2844443800;
  loadarray[99]=0x384444442800;
  loadarray[100]=0x384444287F00;
  loadarray[101]=0x385454541800;
  loadarray[102]=0x087E090200;
  loadarray[103]=0x18A4A49C7800;
  loadarray[104]=0x7F0804047800;
  loadarray[105]=0x447D400000;
  loadarray[106]=0x2040403D0000;
  loadarray[107]=0x7F1028440000;
  loadarray[108]=0x417F400000;
  loadarray[109]=0x7C0478047800;
  loadarray[110]=0x7C0804047800;
  loadarray[111]=0x384444443800;
  loadarray[112]=0xFC1824241800;
  loadarray[113]=0x18242418FC00;
  loadarray[114]=0x7C0804040800;
  loadarray[115]=0x485454542400;
  loadarray[116]=0x04043F442400;
  loadarray[117]=0x3C4040207C00;
  loadarray[118]=0x1C2040201C00;
  loadarray[119]=0x3C4030403C00;
  loadarray[120]=0x442810284400;
  loadarray[121]=0x4C9090907C00;
  loadarray[122]=0x4464544C4400;
  loadarray[123]=0x0836410000;
  loadarray[124]=0x0077000000;
  loadarray[125]=0x4136080000;
  loadarray[126]=0x020102040200;
  loadarray[127]=0x3C2623263C00;
  loadarray[128]=0x1EA1A1611200;
  loadarray[129]=0x3A4040207A00;
  loadarray[130]=0x385454555900;
  loadarray[131]=0x215555794100;
  loadarray[132]=0x225454784200;
  loadarray[133]=0x215554784000;
  loadarray[134]=0x205455794000;
  loadarray[135]=0x0C1E52721200;
  loadarray[136]=0x395555555900;
  loadarray[137]=0x395454545900;
  loadarray[138]=0x395554545800;
  loadarray[139]=0x00457C4100;
  loadarray[140]=0x02457D4200;
  loadarray[141]=0x01457C4000;
  loadarray[142]=0x7D1211127D00;
  loadarray[143]=0xF0282528F000;
  loadarray[144]=0x7C5455450000;
  loadarray[145]=0x2054547C5400;
  loadarray[146]=0x7C0A097F4900;
  loadarray[147]=0x324949493200;
  loadarray[148]=0x3A4444443A00;
  loadarray[149]=0x324A48483000;
  loadarray[150]=0x3A4141217A00;
  loadarray[151]=0x3A4240207800;
  loadarray[152]=0x9DA0A07D00;
  loadarray[153]=0x3D4242423D00;
  loadarray[154]=0x3D4040403D00;
  loadarray[155]=0x3C24FF242400;
  loadarray[156]=0x487E49436600;
  loadarray[157]=0x2B2FFC2F2B00;
  loadarray[158]=0xFF0929F62000;
  loadarray[159]=0xC0887E090300;
  loadarray[160]=0x205454794100;
  loadarray[161]=0x00447D4100;
  loadarray[162]=0x3048484A3200;
  loadarray[163]=0x384040227A00;
  loadarray[164]=0x7A0A0A7200;
  loadarray[165]=0x7D0D19317D00;
  loadarray[166]=0x2629292F2800;
  loadarray[167]=0x262929292600;
  loadarray[168]=0x30484D402000;
  loadarray[169]=0x380808080800;
  loadarray[170]=0x080808083800;
  loadarray[171]=0x2F10C8ACBA00;
  loadarray[172]=0x2F102834FA00;
  loadarray[173]=0x007B000000;
  loadarray[174]=0x08142A142200;
  loadarray[175]=0x22142A140800;
  loadarray[176]=0xAA005500AA00;
  loadarray[177]=0xAA55AA55AA00;
  loadarray[178]=0x0000FF0000;
  loadarray[179]=0x101010FF0000;
  loadarray[180]=0x141414FF0000;
  loadarray[181]=0x1010FF00FF00;
  loadarray[182]=0x1010F010F000;
  loadarray[183]=0x141414FC0000;
  loadarray[184]=0x1414F700FF00;
  loadarray[185]=0x00FF00FF00;
  loadarray[186]=0x1414F404FC00;
  loadarray[187]=0x141417101F00;
  loadarray[188]=0x10101F101F00;
  loadarray[189]=0x1414141F0000;
  loadarray[190]=0x101010F00000;
  loadarray[191]=0x00001F1000;
  loadarray[192]=0x1010101F1000;
  loadarray[193]=0x101010F01000;
  loadarray[194]=0x0000FF1000;
  loadarray[195]=0x101010101000;
  loadarray[196]=0x101010FF1000;
  loadarray[197]=0x0000FF1400;
  loadarray[198]=0x00FF00FF00;
  loadarray[199]=0x001F101700;
  loadarray[200]=0x00FC04F400;
  loadarray[201]=0x141417101700;
  loadarray[202]=0x1414F404F400;
  loadarray[203]=0x00FF00F700;
  loadarray[204]=0x141414141400;
  loadarray[205]=0x1414F700F700;
  loadarray[206]=0x141414171400;
  loadarray[207]=0x10101F101F00;
  loadarray[208]=0x141414F41400;
  loadarray[209]=0x1010F010F000;
  loadarray[210]=0x001F101F00;
  loadarray[211]=0x00001F1400;
  loadarray[212]=0x0000FC1400;
  loadarray[213]=0x00F010F000;
  loadarray[214]=0x1010FF10FF00;
  loadarray[215]=0x141414FF1400;
  loadarray[216]=0x1010101F0000;
  loadarray[217]=0x0000F01000;
  loadarray[218]=0xFFFFFFFFFF00;
  loadarray[219]=0xF0F0F0F0F000;
  loadarray[220]=0xFFFFFF000000;
  loadarray[221]=0x0000FFFF00;
  loadarray[222]=0x0F0F0F0F0F00;
  loadarray[223]=0x384444384400;
  loadarray[224]=0xFC4A4A4A3400;
  loadarray[225]=0x7E0202060600;
  loadarray[226]=0x027E027E0200;
  loadarray[227]=0x635549416300;
  loadarray[228]=0x3844443C0400;
  loadarray[229]=0x407E201E2000;
  loadarray[230]=0x06027E020200;
  loadarray[231]=0x99A5E7A59900;
  loadarray[232]=0x1C2A492A1C00;
  loadarray[233]=0x4C7201724C00;
  loadarray[234]=0x304A4D4D3000;
  loadarray[235]=0x304878483000;
  loadarray[236]=0xBC625A463D00;
  loadarray[237]=0x3E4949490000;
  loadarray[238]=0x7E0101017E00;
  loadarray[239]=0x2A2A2A2A2A00;
  loadarray[240]=0x44445F444400;
  loadarray[241]=0x40514A444000;
  loadarray[242]=0x40444A514000;
  loadarray[243]=0x00FF010300;
  loadarray[244]=0xE080FF000000;
  loadarray[245]=0x08086B6B0800;
  loadarray[246]=0x361236243600;
  loadarray[247]=0x060F090F0600;
  loadarray[248]=0x0018180000;
  loadarray[249]=0x0010100000;
  loadarray[250]=0x3040FF010100;
  loadarray[251]=0x1F01011E00;
  loadarray[252]=0x191D171200;
  loadarray[253]=0x3C3C3C3C00;
  loadarray[254]=0x0000000000;
 return (i);
}
void main(){}
